/*  aqotdd - Afghan's Quote of the day server - An RFC865 compliant server.
    Copyright (C) 2000 Afghan Hound Software

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/

/*  daemon.c - daemonizes process, starts logging, drops root (when availible) */

#include "main.h"


void daemon_loginit();
void daemon_changeuser();
void daemonize();

void daemon_loginit()
{
  if (!use_sys)
    {
      log_fileh = fopen(log_file,"a");
      if (log_fileh==NULL)
	{
	  my_message(MSG_ERRFAIL,"Couldn't open log file.",log_file);
	} 
    }
  else
    {
#if HAVE_SYSLOG_H
      openlog("aqotdd",LOG_PID,LOG_DAEMON);
#endif
    }
  if ((use_sys)||(log_fileh!=NULL))
    {
      /* If we've got somewhere to log to, close std in/out/err */
      close(0);
      close(1);
      close(2);
      open("/dev/null",O_RDWR);
      open("/dev/null",O_RDWR);
      open("/dev/null",O_RDWR);
    }
}

void daemon_changeuser()
{
  struct passwd *user;
  uid_t uid1;
  char buffer[200];
  if ((user=getpwnam(def_user))==NULL)
    {
      my_message(MSG_NO_USER,"Can't find username, trying uid","");
      uid1=atoi(def_user);
      if ((user=getpwuid(uid1))==NULL)
	{
	  my_message(MSG_NO_USER,"Can't find user id, trying nobody","");
	  if ((user=getpwnam("nobody"))==NULL)
	    {
	      my_message(MSG_NO_USER,"Can't find user 'nobody', staying as me","");
	    }
	}
    }
  if (user!=NULL)
    {
      /* Goodbye Root */
      setuid(user->pw_uid);
      setgid(user->pw_gid);
      user = getpwuid(getuid());
      sprintf(buffer,"Changed user to %d(%s), group %d",(int)(user->pw_uid),user->pw_name,(int)(user->pw_gid));
      my_message(MSG_CHGUSER,buffer,"");
    }
}

void daemonize()
{
  switch (fork())
    {
    case 0:  break;
    case -1: exit(1);
    default: _exit(0);         
    }
  
  if (setsid() < 0){exit(1);}
  switch (fork())
    {
    case 0:  break;
    case -1: exit(1);
    default: _exit(0);
    }
  umask(0);
  my_message(MSG_INITFINISH,"Backgrounded","");
}

void daemon_init()
{
  my_message(MSG_INITSTART,"Starting deamon init","");
  if (!debug_flag)
    {
      if (daemon_flag)
	{
	  daemonize();
	}
      daemon_loginit();
      daemon_changeuser();
    }
}
